// Autogenerated by convert_tests.py and process_polyglot.py.
// Do not edit this file directly.
// The template for this file is located at:
// ../../../../../../../templates/Test.java
package com.rethinkdb.gen;

import com.rethinkdb.RethinkDB;
import com.rethinkdb.gen.exc.*;
import com.rethinkdb.gen.ast.*;
import com.rethinkdb.ast.ReqlAst;
import com.rethinkdb.model.MapObject;
import com.rethinkdb.model.OptArgs;
import com.rethinkdb.net.Connection;
import com.rethinkdb.net.Cursor;
import junit.framework.TestCase;
import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertArrayEquals;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import org.junit.*;
import org.junit.rules.ExpectedException;

import java.util.Arrays;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.time.OffsetDateTime;
import java.time.ZoneOffset;
import java.time.Instant;
import java.util.stream.LongStream;
import java.util.stream.Collectors;
import java.util.stream.Stream;
import java.util.concurrent.TimeoutException;
import java.util.regex.Pattern;
import java.util.Collections;
import java.nio.charset.StandardCharsets;

import static com.rethinkdb.TestingCommon.*;
import com.rethinkdb.TestingFramework;

public class DatumObject {
    // Tests conversion to and from the RQL object type
    Logger logger = LoggerFactory.getLogger(DatumObject.class);
    public static final RethinkDB r = RethinkDB.r;

    Connection conn;

    @Before
    public void setUp() throws Exception {
        logger.info("Setting up.");
        conn = TestingFramework.createConnection();
        try {
            r.dbCreate("test").run(conn);
            r.db("test").wait_().run(conn);
        }catch (Exception e){}
    }

    @After
    public void tearDown() throws Exception {
        logger.info("Tearing down.");
        r.db("rethinkdb").table("_debug_scratch").delete().run(conn);
        if(!conn.isOpen()){
            conn.close();
            conn = TestingFramework.createConnection();
        }
        r.dbDrop("test").run(conn);
        conn.close(false);
    }

    // Autogenerated tests below

    @Test(timeout=120000)
    public void test() throws Exception {

        {
            // datum/object.yaml line #6
            /* {} */
            Map expected_ = r.hashMap();
            /* r.expr({}) */
            logger.info("About to run line #6: r.expr(r.hashMap())");
            Object obtained = runOrCatch(r.expr(r.hashMap()),
                                          new OptArgs()
                                          ,conn);
            try {
                assertEquals(expected_, obtained);
            logger.info("Finished running line #6");
            } catch (Throwable ae) {
                logger.error("Whoops, got exception on line #6:" + ae.toString());
                if(obtained instanceof Throwable) {
                    ae.addSuppressed((Throwable) obtained);
                }
                throw ae;
            }
        }

        {
            // datum/object.yaml line #11
            /* {'a':1} */
            Map expected_ = r.hashMap("a", 1L);
            /* r.expr({'a':1}) */
            logger.info("About to run line #11: r.expr(r.hashMap('a', 1L))");
            Object obtained = runOrCatch(r.expr(r.hashMap("a", 1L)),
                                          new OptArgs()
                                          ,conn);
            try {
                assertEquals(expected_, obtained);
            logger.info("Finished running line #11");
            } catch (Throwable ae) {
                logger.error("Whoops, got exception on line #11:" + ae.toString());
                if(obtained instanceof Throwable) {
                    ae.addSuppressed((Throwable) obtained);
                }
                throw ae;
            }
        }

        {
            // datum/object.yaml line #16
            /* {'a':1, 'b':'two', 'c':True} */
            Map expected_ = r.hashMap("a", 1L).with("b", "two").with("c", true);
            /* r.expr({'a':1, 'b':'two', 'c':True}) */
            logger.info("About to run line #16: r.expr(r.hashMap('a', 1L).with('b', 'two').with('c', true))");
            Object obtained = runOrCatch(r.expr(r.hashMap("a", 1L).with("b", "two").with("c", true)),
                                          new OptArgs()
                                          ,conn);
            try {
                assertEquals(expected_, obtained);
            logger.info("Finished running line #16");
            } catch (Throwable ae) {
                logger.error("Whoops, got exception on line #16:" + ae.toString());
                if(obtained instanceof Throwable) {
                    ae.addSuppressed((Throwable) obtained);
                }
                throw ae;
            }
        }

        {
            // datum/object.yaml line #20
            /* {'a':1} */
            Map expected_ = r.hashMap("a", 1L);
            /* r.expr({'a':r.expr(1)}) */
            logger.info("About to run line #20: r.expr(r.hashMap('a', r.expr(1L)))");
            Object obtained = runOrCatch(r.expr(r.hashMap("a", r.expr(1L))),
                                          new OptArgs()
                                          ,conn);
            try {
                assertEquals(expected_, obtained);
            logger.info("Finished running line #20");
            } catch (Throwable ae) {
                logger.error("Whoops, got exception on line #20:" + ae.toString());
                if(obtained instanceof Throwable) {
                    ae.addSuppressed((Throwable) obtained);
                }
                throw ae;
            }
        }

        {
            // datum/object.yaml line #23
            /* {'a':{'b':[{'c':2}, 'a', 4]}} */
            Map expected_ = r.hashMap("a", r.hashMap("b", r.array(r.hashMap("c", 2L), "a", 4L)));
            /* r.expr({'a':{'b':[{'c':2}, 'a', 4]}}) */
            logger.info("About to run line #23: r.expr(r.hashMap('a', r.hashMap('b', r.array(r.hashMap('c', 2L), 'a', 4L))))");
            Object obtained = runOrCatch(r.expr(r.hashMap("a", r.hashMap("b", r.array(r.hashMap("c", 2L), "a", 4L)))),
                                          new OptArgs()
                                          ,conn);
            try {
                assertEquals(expected_, obtained);
            logger.info("Finished running line #23");
            } catch (Throwable ae) {
                logger.error("Whoops, got exception on line #23:" + ae.toString());
                if(obtained instanceof Throwable) {
                    ae.addSuppressed((Throwable) obtained);
                }
                throw ae;
            }
        }

        {
            // datum/object.yaml line #26
            /* 'OBJECT' */
            String expected_ = "OBJECT";
            /* r.expr({'a':1}).type_of() */
            logger.info("About to run line #26: r.expr(r.hashMap('a', 1L)).typeOf()");
            Object obtained = runOrCatch(r.expr(r.hashMap("a", 1L)).typeOf(),
                                          new OptArgs()
                                          ,conn);
            try {
                assertEquals(expected_, obtained);
            logger.info("Finished running line #26");
            } catch (Throwable ae) {
                logger.error("Whoops, got exception on line #26:" + ae.toString());
                if(obtained instanceof Throwable) {
                    ae.addSuppressed((Throwable) obtained);
                }
                throw ae;
            }
        }

        {
            // datum/object.yaml line #30
            /* '{"a":1}' */
            String expected_ = "{\"a\":1}";
            /* r.expr({'a':1}).coerce_to('string') */
            logger.info("About to run line #30: r.expr(r.hashMap('a', 1L)).coerceTo('string')");
            Object obtained = runOrCatch(r.expr(r.hashMap("a", 1L)).coerceTo("string"),
                                          new OptArgs()
                                          ,conn);
            try {
                assertEquals(expected_, obtained);
            logger.info("Finished running line #30");
            } catch (Throwable ae) {
                logger.error("Whoops, got exception on line #30:" + ae.toString());
                if(obtained instanceof Throwable) {
                    ae.addSuppressed((Throwable) obtained);
                }
                throw ae;
            }
        }

        {
            // datum/object.yaml line #34
            /* {'a':1} */
            Map expected_ = r.hashMap("a", 1L);
            /* r.expr({'a':1}).coerce_to('object') */
            logger.info("About to run line #34: r.expr(r.hashMap('a', 1L)).coerceTo('object')");
            Object obtained = runOrCatch(r.expr(r.hashMap("a", 1L)).coerceTo("object"),
                                          new OptArgs()
                                          ,conn);
            try {
                assertEquals(expected_, obtained);
            logger.info("Finished running line #34");
            } catch (Throwable ae) {
                logger.error("Whoops, got exception on line #34:" + ae.toString());
                if(obtained instanceof Throwable) {
                    ae.addSuppressed((Throwable) obtained);
                }
                throw ae;
            }
        }

        {
            // datum/object.yaml line #37
            /* [['a',1]] */
            List expected_ = r.array(r.array("a", 1L));
            /* r.expr({'a':1}).coerce_to('array') */
            logger.info("About to run line #37: r.expr(r.hashMap('a', 1L)).coerceTo('array')");
            Object obtained = runOrCatch(r.expr(r.hashMap("a", 1L)).coerceTo("array"),
                                          new OptArgs()
                                          ,conn);
            try {
                assertEquals(expected_, obtained);
            logger.info("Finished running line #37");
            } catch (Throwable ae) {
                logger.error("Whoops, got exception on line #37:" + ae.toString());
                if(obtained instanceof Throwable) {
                    ae.addSuppressed((Throwable) obtained);
                }
                throw ae;
            }
        }

        {
            // datum/object.yaml line #66
            /* {} */
            Map expected_ = r.hashMap();
            /* r.object() */
            logger.info("About to run line #66: r.object()");
            Object obtained = runOrCatch(r.object(),
                                          new OptArgs()
                                          ,conn);
            try {
                assertEquals(expected_, obtained);
            logger.info("Finished running line #66");
            } catch (Throwable ae) {
                logger.error("Whoops, got exception on line #66:" + ae.toString());
                if(obtained instanceof Throwable) {
                    ae.addSuppressed((Throwable) obtained);
                }
                throw ae;
            }
        }

        {
            // datum/object.yaml line #69
            /* {'a':1,'b':2} */
            Map expected_ = r.hashMap("a", 1L).with("b", 2L);
            /* r.object('a', 1, 'b', 2) */
            logger.info("About to run line #69: r.object('a', 1L, 'b', 2L)");
            Object obtained = runOrCatch(r.object("a", 1L, "b", 2L),
                                          new OptArgs()
                                          ,conn);
            try {
                assertEquals(expected_, obtained);
            logger.info("Finished running line #69");
            } catch (Throwable ae) {
                logger.error("Whoops, got exception on line #69:" + ae.toString());
                if(obtained instanceof Throwable) {
                    ae.addSuppressed((Throwable) obtained);
                }
                throw ae;
            }
        }

        {
            // datum/object.yaml line #72
            /* {'cd':3} */
            Map expected_ = r.hashMap("cd", 3L);
            /* r.object('c'+'d', 3) */
            logger.info("About to run line #72: r.object(r.add('c', 'd'), 3L)");
            Object obtained = runOrCatch(r.object(r.add("c", "d"), 3L),
                                          new OptArgs()
                                          ,conn);
            try {
                assertEquals(expected_, obtained);
            logger.info("Finished running line #72");
            } catch (Throwable ae) {
                logger.error("Whoops, got exception on line #72:" + ae.toString());
                if(obtained instanceof Throwable) {
                    ae.addSuppressed((Throwable) obtained);
                }
                throw ae;
            }
        }

        {
            // datum/object.yaml line #78
            /* err("ReqlQueryLogicError","Expected type STRING but found NUMBER.",[]) */
            Err expected_ = err("ReqlQueryLogicError", "Expected type STRING but found NUMBER.", r.array());
            /* r.object(1, 1) */
            logger.info("About to run line #78: r.object(1L, 1L)");
            Object obtained = runOrCatch(r.object(1L, 1L),
                                          new OptArgs()
                                          ,conn);
            try {
                assertEquals(expected_, obtained);
            logger.info("Finished running line #78");
            } catch (Throwable ae) {
                logger.error("Whoops, got exception on line #78:" + ae.toString());
                if(obtained instanceof Throwable) {
                    ae.addSuppressed((Throwable) obtained);
                }
                throw ae;
            }
        }

        {
            // datum/object.yaml line #81
            /* err("ReqlQueryLogicError","Duplicate key \"e\" in object.  (got 4 and 5 as values)",[]) */
            Err expected_ = err("ReqlQueryLogicError", "Duplicate key \"e\" in object.  (got 4 and 5 as values)", r.array());
            /* r.object('e', 4, 'e', 5) */
            logger.info("About to run line #81: r.object('e', 4L, 'e', 5L)");
            Object obtained = runOrCatch(r.object("e", 4L, "e", 5L),
                                          new OptArgs()
                                          ,conn);
            try {
                assertEquals(expected_, obtained);
            logger.info("Finished running line #81");
            } catch (Throwable ae) {
                logger.error("Whoops, got exception on line #81:" + ae.toString());
                if(obtained instanceof Throwable) {
                    ae.addSuppressed((Throwable) obtained);
                }
                throw ae;
            }
        }

        {
            // datum/object.yaml line #84
            /* err("ReqlQueryLogicError","Expected type DATUM but found DATABASE:",[]) */
            Err expected_ = err("ReqlQueryLogicError", "Expected type DATUM but found DATABASE:", r.array());
            /* r.object('g', r.db('test')) */
            logger.info("About to run line #84: r.object('g', r.db('test'))");
            Object obtained = runOrCatch(r.object("g", r.db("test")),
                                          new OptArgs()
                                          ,conn);
            try {
                assertEquals(expected_, obtained);
            logger.info("Finished running line #84");
            } catch (Throwable ae) {
                logger.error("Whoops, got exception on line #84:" + ae.toString());
                if(obtained instanceof Throwable) {
                    ae.addSuppressed((Throwable) obtained);
                }
                throw ae;
            }
        }
    }
}
