// Autogenerated by convert_tests.py and process_polyglot.py.
// Do not edit this file directly.
// The template for this file is located at:
// ../../../../../../../templates/Test.java
package com.rethinkdb.gen;

import com.rethinkdb.RethinkDB;
import com.rethinkdb.gen.exc.*;
import com.rethinkdb.gen.ast.*;
import com.rethinkdb.ast.ReqlAst;
import com.rethinkdb.model.MapObject;
import com.rethinkdb.model.OptArgs;
import com.rethinkdb.net.Connection;
import com.rethinkdb.net.Cursor;
import junit.framework.TestCase;
import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertArrayEquals;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import org.junit.*;
import org.junit.rules.ExpectedException;

import java.util.Arrays;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.time.OffsetDateTime;
import java.time.ZoneOffset;
import java.time.Instant;
import java.util.stream.LongStream;
import java.util.stream.Collectors;
import java.util.stream.Stream;
import java.util.concurrent.TimeoutException;
import java.util.regex.Pattern;
import java.util.Collections;
import java.nio.charset.StandardCharsets;

import static com.rethinkdb.TestingCommon.*;
import com.rethinkdb.TestingFramework;

public class Polymorphism {
    // Tests that manipulation data in tables
    Logger logger = LoggerFactory.getLogger(Polymorphism.class);
    public static final RethinkDB r = RethinkDB.r;
    public static final Table tbl = r.db("test").table("tbl");

    Connection conn;

    @Before
    public void setUp() throws Exception {
        logger.info("Setting up.");
        conn = TestingFramework.createConnection();
        try {
            r.dbCreate("test").run(conn);
            r.db("test").wait_().run(conn);
        }catch (Exception e){}
        try {
            r.db("test").tableCreate("tbl").run(conn);
            r.db("test").table(tbl).wait_().run(conn);
        }catch (Exception e){}
    }

    @After
    public void tearDown() throws Exception {
        logger.info("Tearing down.");
        r.db("rethinkdb").table("_debug_scratch").delete().run(conn);
        if(!conn.isOpen()){
            conn.close();
            conn = TestingFramework.createConnection();
        }
        r.db("test").tableDrop("tbl").run(conn);
        r.dbDrop("test").run(conn);
        conn.close(false);
    }

    // Autogenerated tests below

    @Test(timeout=120000)
    public void test() throws Exception {

        // polymorphism.yaml line #5
        // obj = r.expr({'id':0,'a':0})
        logger.info("Possibly executing: MakeObj obj = (MakeObj) (r.expr(r.hashMap('id', 0L).with('a', 0L)));");
        MakeObj obj = (MakeObj) (r.expr(r.hashMap("id", 0L).with("a", 0L)));

        {
            // polymorphism.yaml line #7
            /* ({'deleted':0,'replaced':0,'unchanged':0,'errors':0,'skipped':0,'inserted':3}) */
            Map expected_ = r.hashMap("deleted", 0L).with("replaced", 0L).with("unchanged", 0L).with("errors", 0L).with("skipped", 0L).with("inserted", 3L);
            /* tbl.insert([{'id':i, 'a':i} for i in xrange(3)]) */
            logger.info("About to run line #7: tbl.insert(LongStream.range(0, 3L).boxed().map(i -> r.hashMap('id', i).with('a', i)).collect(Collectors.toList()))");
            Object obtained = runOrCatch(tbl.insert(LongStream.range(0, 3L).boxed().map(i -> r.hashMap("id", i).with("a", i)).collect(Collectors.toList())),
                                          new OptArgs()
                                          ,conn);
            try {
                assertEquals(expected_, obtained);
            logger.info("Finished running line #7");
            } catch (Throwable ae) {
                logger.error("Whoops, got exception on line #7:" + ae.toString());
                if(obtained instanceof Throwable) {
                    ae.addSuppressed((Throwable) obtained);
                }
                throw ae;
            }
        }

        {
            // polymorphism.yaml line #21
            /* ({'id':0,'c':1,'a':0}) */
            Map expected_ = r.hashMap("id", 0L).with("c", 1L).with("a", 0L);
            /* tbl.merge({'c':1}).nth(0) */
            logger.info("About to run line #21: tbl.merge(r.hashMap('c', 1L)).nth(0L)");
            Object obtained = runOrCatch(tbl.merge(r.hashMap("c", 1L)).nth(0L),
                                          new OptArgs()
                                          ,conn);
            try {
                assertEquals(expected_, obtained);
            logger.info("Finished running line #21");
            } catch (Throwable ae) {
                logger.error("Whoops, got exception on line #21:" + ae.toString());
                if(obtained instanceof Throwable) {
                    ae.addSuppressed((Throwable) obtained);
                }
                throw ae;
            }
        }

        {
            // polymorphism.yaml line #22
            /* ({'id':0,'c':1,'a':0}) */
            Map expected_ = r.hashMap("id", 0L).with("c", 1L).with("a", 0L);
            /* obj.merge({'c':1}) */
            logger.info("About to run line #22: obj.merge(r.hashMap('c', 1L))");
            Object obtained = runOrCatch(obj.merge(r.hashMap("c", 1L)),
                                          new OptArgs()
                                          ,conn);
            try {
                assertEquals(expected_, obtained);
            logger.info("Finished running line #22");
            } catch (Throwable ae) {
                logger.error("Whoops, got exception on line #22:" + ae.toString());
                if(obtained instanceof Throwable) {
                    ae.addSuppressed((Throwable) obtained);
                }
                throw ae;
            }
        }

        {
            // polymorphism.yaml line #26
            /* ({'id':0}) */
            Map expected_ = r.hashMap("id", 0L);
            /* tbl.without('a').nth(0) */
            logger.info("About to run line #26: tbl.without('a').nth(0L)");
            Object obtained = runOrCatch(tbl.without("a").nth(0L),
                                          new OptArgs()
                                          ,conn);
            try {
                assertEquals(expected_, obtained);
            logger.info("Finished running line #26");
            } catch (Throwable ae) {
                logger.error("Whoops, got exception on line #26:" + ae.toString());
                if(obtained instanceof Throwable) {
                    ae.addSuppressed((Throwable) obtained);
                }
                throw ae;
            }
        }

        {
            // polymorphism.yaml line #27
            /* ({'id':0}) */
            Map expected_ = r.hashMap("id", 0L);
            /* obj.without('a') */
            logger.info("About to run line #27: obj.without('a')");
            Object obtained = runOrCatch(obj.without("a"),
                                          new OptArgs()
                                          ,conn);
            try {
                assertEquals(expected_, obtained);
            logger.info("Finished running line #27");
            } catch (Throwable ae) {
                logger.error("Whoops, got exception on line #27:" + ae.toString());
                if(obtained instanceof Throwable) {
                    ae.addSuppressed((Throwable) obtained);
                }
                throw ae;
            }
        }

        {
            // polymorphism.yaml line #31
            /* ({'a':0}) */
            Map expected_ = r.hashMap("a", 0L);
            /* tbl.pluck('a').nth(0) */
            logger.info("About to run line #31: tbl.pluck('a').nth(0L)");
            Object obtained = runOrCatch(tbl.pluck("a").nth(0L),
                                          new OptArgs()
                                          ,conn);
            try {
                assertEquals(expected_, obtained);
            logger.info("Finished running line #31");
            } catch (Throwable ae) {
                logger.error("Whoops, got exception on line #31:" + ae.toString());
                if(obtained instanceof Throwable) {
                    ae.addSuppressed((Throwable) obtained);
                }
                throw ae;
            }
        }

        {
            // polymorphism.yaml line #32
            /* ({'a':0}) */
            Map expected_ = r.hashMap("a", 0L);
            /* obj.pluck('a') */
            logger.info("About to run line #32: obj.pluck('a')");
            Object obtained = runOrCatch(obj.pluck("a"),
                                          new OptArgs()
                                          ,conn);
            try {
                assertEquals(expected_, obtained);
            logger.info("Finished running line #32");
            } catch (Throwable ae) {
                logger.error("Whoops, got exception on line #32:" + ae.toString());
                if(obtained instanceof Throwable) {
                    ae.addSuppressed((Throwable) obtained);
                }
                throw ae;
            }
        }
    }
}
